//+------------------------------------------------------------------+
//|                                     Fractals - adjustable period |
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Crimson
#property indicator_width1  0
#property indicator_width2  0

//
//
//
//
//

extern int    FractalPeriod          = 26;
extern double UpperArrowDisplacement = 0.0;
extern double LowerArrowDisplacement = 0.0;
extern color  upcolor                = DeepSkyBlue;
extern color  dncolor                = Crimson;
extern int    Arrow.code             = 250;

double UpperBuffer[];
double LowerBuffer[];
string UniqueID = "fap";
datetime time;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   if (MathMod(FractalPeriod,2)== 0)
         FractalPeriod = FractalPeriod + 1;

   SetIndexBuffer(0,UpperBuffer); SetIndexStyle(0,3,EMPTY,EMPTY,upcolor); SetIndexArrow(0,Arrow.code);
   SetIndexBuffer(1,LowerBuffer); SetIndexStyle(1,3,EMPTY,EMPTY,dncolor); SetIndexArrow(1,Arrow.code);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit()
{
   string lookFor       = UniqueID;
   int    lookForLength = StringLen(lookFor);   
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i);
         if(StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
   }         
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int half = FractalPeriod/2;
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(MathMax(Bars-counted_bars,FractalPeriod),Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      bool   found     = true;
      double compareTo = High[i];
      time = StrToTime(TimeToStr(Time[i], TIME_DATE|TIME_MINUTES));
      string fh = UniqueID + "-fh: " + time;
      string fl = UniqueID + "-fl: " + time;
      for (int k=1;k<=half;k++)
      {
         if ((i+k)<Bars && High[i+k]> compareTo) { found=false; /*if(ObjectFind(fh) == 0)*/ ObjectDelete(fh); break; }
         if ((i-k)>=0   && High[i-k]>=compareTo) { found=false; /*if(ObjectFind(fh) == 0)*/ ObjectDelete(fh); break; }
      }
      if (found)
      { 
         UpperBuffer[i]=High[i]+iATR(NULL,0,20,i)*UpperArrowDisplacement;
         /*if(ObjectFind(fh) == 0)*/ ObjectDelete(fh);
            ObjectCreate (fh, OBJ_TEXT, 0, 0, 0); //(fh, OBJ_TEXT, 0, time, UpperBuffer[i] + iATR(NULL,0,20,i)*0.4);
            ObjectSetText(fh, DoubleToStr(UpperBuffer[i],Digits), 8, "Verdana", upcolor);
            ObjectMove   (fh, 0,time, UpperBuffer[i] + iATR(NULL,0,20,i)*0.4);
      }
      else UpperBuffer[i]=UpperBuffer[i+1];
         
      //
      //
      //
      //
      //
      
      found     = true;
      compareTo = Low[i];
      for (k=1;k<=half;k++)
      {
         if ((i+k)<Bars && Low[i+k]< compareTo) { found=false; /*if(ObjectFind(fl) == 0)*/ ObjectDelete(fl); break; }
         if ((i-k)>=0   && Low[i-k]<=compareTo) { found=false; /*if(ObjectFind(fl) == 0)*/ ObjectDelete(fl); break; }
      }
      if (found)
      { 
         LowerBuffer[i]=Low[i]-iATR(NULL,0,20,i)*LowerArrowDisplacement;
         /*if(ObjectFind(fl) == 0)*/ ObjectDelete(fl);
            ObjectCreate (fl, OBJ_TEXT, 0, 0, 0); //(fl, OBJ_TEXT, 0, time, LowerBuffer[i] - iATR(NULL,0,20,i)*0.1);
            ObjectSetText(fl, DoubleToStr(LowerBuffer[i],Digits), 8, "Verdana", dncolor);
            ObjectMove   (fl, 0,time, LowerBuffer[i] - iATR(NULL,0,20,i)*0.1);
      }
      else LowerBuffer[i]=LowerBuffer[i+1];
   }
   return(0);
}